/*======================[HDR LIGHTMAP, TEXTURE LOD HLSL Shader by ASMODEAN(KIERANH7)][This is a DX10+ shader]===========*/

#ifdef SHADER_MODEL
#define HLSL_5 1

float viewWidth;
float viewHeight;
float near;
float far;

Buffer<float4> g_Buffer;

float4	ScreenSize;
float4	TempParameters; 
float4	LenzParameters;

float4 HDRRadius1;
float4 HDRRadius2;
float4 HDRBlueShiftAmount;
float4 HDRContrast;
float4 HDRParameters;


Texture2DMS<float4, 8>MultisampledTexture;
SamplerState gcolorSampler
{
    Texture   = <MultisampledTexture>;
	MinFilter = ANISOTROPIC;
	MagFilter = ANISOTROPIC;
	MipFilter = ANISOTROPIC;//NONE;
	MaxAnisotropy = 16;
	AddressU = Clamp;
	AddressV = Clamp;
	AddressW = Clamp;
	SRGBTexture=true;
	MaxMipLevel=0;
	MipMapLodBias=0;
};
Texture2D gdepth;
SamplerState gdepthSampler
{
    Texture   = <gdepth>;
	MinFilter = ANISOTROPIC;
	MagFilter = ANISOTROPIC;
	MipFilter = ANISOTROPIC;//NONE;
	MaxAnisotropy = 16;
	AddressU = Clamp;
	AddressV = Clamp;
	AddressW = Clamp;
	SRGBTexture=true;
	MaxMipLevel=0;
	MipMapLodBias=0;
};

Texture2D gnormal;
SamplerState gnormalSampler
{
    Texture   = <gnormal>;
	MinFilter = ANISOTROPIC;
	MagFilter = ANISOTROPIC;
	MipFilter = ANISOTROPIC;//NONE;
	MaxAnisotropy = 16;
	AddressU = Clamp;
	AddressV = Clamp;
	AddressW = Clamp;
	SRGBTexture=true;
	MaxMipLevel=0;
	MipMapLodBias=0;
};

Texture2D composite;
SamplerState compositeSampler
{
    Texture   = <composite>;
	MinFilter = ANISOTROPIC;
	MagFilter = ANISOTROPIC;
	MipFilter = ANISOTROPIC;//NONE;
	MaxAnisotropy = 16;
	AddressU = Clamp;
	AddressV = Clamp;
	AddressW = Clamp;
	SRGBTexture=true;
	MaxMipLevel=0;
	MipMapLodBias=0;
};


Texture2D DiffuseTexture;
SamplerState DiffuseTextureSampler
{
    Texture   = <DiffuseTexture>;
	MinFilter = ANISOTROPIC;
	MagFilter = ANISOTROPIC;
	MipFilter = ANISOTROPIC;//NONE;
	MaxAnisotropy = 16;
	AddressU = Clamp;
	AddressV = Clamp;
	AddressW = Clamp;
	SRGBTexture=true;
	MaxMipLevel=0;
	MipMapLodBias=0;
};
Texture2D _texture;
SamplerState _textureSampler
{
    Texture   = <_texture>;
	MinFilter = ANISOTROPIC;
	MagFilter = ANISOTROPIC;
	MipFilter = ANISOTROPIC;//NONE;
	MaxAnisotropy = 16;
	AddressU = Clamp;
	AddressV = Clamp;
	AddressW = Clamp;
	SRGBTexture=true;
	MaxMipLevel=0;
	MipMapLodBias=0;
};

Texture2D texturesample;
SamplerState TextureSampler
{
    Texture   = <Texture>;
	MinFilter = ANISOTROPIC;
	MagFilter = ANISOTROPIC;
	MipFilter = ANISOTROPIC;//NONE;
	MaxAnisotropy = 16;
	AddressU = Clamp;
	AddressV = Clamp;
	AddressW = Clamp;
	SRGBTexture=true;
	MaxMipLevel=0;
	MipMapLodBias=0;
};

Texture2D textureLOD1;
SamplerState TextureSampler1
{
    Texture   = <textureLOD1>;
	MinFilter = ANISOTROPIC;
	MagFilter = ANISOTROPIC;
	MipFilter = ANISOTROPIC;//NONE;
	MaxAnisotropy = 16;
	AddressU = Clamp;
	AddressV = Clamp;
	AddressW = Clamp;
	SRGBTexture=true;
	MaxMipLevel=0;
	MipMapLodBias=0;
};

Texture2D textureLOD2;
SamplerState TextureSampler2
{
    Texture   = <textureLOD2>;
	MinFilter = ANISOTROPIC;
	MagFilter = ANISOTROPIC;
	MipFilter = ANISOTROPIC;//NONE;
	MaxAnisotropy = 16;
	AddressU = Clamp;
	AddressV = Clamp;
	AddressW = Clamp;
	SRGBTexture=true;
	MaxMipLevel=0;
	MipMapLodBias=0;
};

Texture2D textureLOD3;
SamplerState TextureSampler3
{
    Texture   = <textureLOD3>;
	MinFilter = ANISOTROPIC;
	MagFilter = ANISOTROPIC;
	MipFilter = ANISOTROPIC;//NONE;
	MaxAnisotropy = 16;
	AddressU = Clamp;
	AddressV = Clamp;
	AddressW = Clamp;
	SRGBTexture=true;
	MaxMipLevel=0;
	MipMapLodBias=0;
};

Texture2D textureLOD4;
SamplerState TextureSampler4
{
    Texture   = <textureLOD4>;
	MinFilter = ANISOTROPIC;
	MagFilter = ANISOTROPIC;
	MipFilter = ANISOTROPIC;//NONE;
	MaxAnisotropy = 16;
	AddressU = Clamp;
	AddressV = Clamp;
	AddressW = Clamp;
	SRGBTexture=true;
	MaxMipLevel=0;
	MipMapLodBias=0;
};

Texture2D textureLOD5;
SamplerState TextureSampler5
{
    Texture   = <textureLOD5>;
	MinFilter = ANISOTROPIC;
	MagFilter = ANISOTROPIC;
	MipFilter = ANISOTROPIC;//NONE;
	MaxAnisotropy = 16;
	AddressU = Clamp;
	AddressV = Clamp;
	AddressW = Clamp;
	SRGBTexture=true;
	MaxMipLevel=0;
	MipMapLodBias=0;
};

Texture2D textureLOD6;
SamplerState TextureSampler6
{
    Texture   = <textureLOD6>;
	MinFilter = ANISOTROPIC;
	MagFilter = ANISOTROPIC;
	MipFilter = ANISOTROPIC;//NONE;
	MaxAnisotropy = 16;
	AddressU = Clamp;
	AddressV = Clamp;
	AddressW = Clamp;
	SRGBTexture=true;
	MaxMipLevel=0;
	MipMapLodBias=0;
};

Texture2D textureLOD7;
SamplerState TextureSampler7
{
    Texture   = <textureLOD7>;
	MinFilter = ANISOTROPIC;
	MagFilter = ANISOTROPIC;
	MipFilter = ANISOTROPIC;//NONE;
	MaxAnisotropy = 16;
	AddressU = Clamp;
	AddressV = Clamp;
	AddressW = Clamp;
	SRGBTexture=true;
	DepthMode = Luminance;
	MaxMipLevel=0;
	MipMapLodBias=0;
};

Texture2D textureLOD8;
SamplerState TextureSampler8
{
    Texture   = <textureLOD8>;
	MinFilter = ANISOTROPIC;
	MagFilter = ANISOTROPIC;
	MipFilter = ANISOTROPIC;//NONE;
	MaxAnisotropy = 16;
	AddressU = Clamp;
	AddressV = Clamp;
	AddressW = Clamp;
	SRGBTexture=true;
	MaxMipLevel=0;
	MipMapLodBias=0;
};

Texture2D gImageSampler;
SamplerState gTextureSampler
{
    Texture   = <gImageSampler>;
	MinFilter = ANISOTROPIC;
	MagFilter = ANISOTROPIC;
	MipFilter = ANISOTROPIC;//NONE;
	MaxAnisotropy = 16;
	AddressU = Clamp;
	AddressV = Clamp;
	AddressW = Clamp;
	SRGBTexture=true;
	MaxMipLevel=0;
	MipMapLodBias=0;
};

cbuffer cb0
{
	float4 _rcpFrame;
	float4 _rcpFrameOpt;
};

cbuffer MatrixBuffer
{
    matrix worldMatrix;
    matrix viewMatrix;
    matrix projectionMatrix;
};

struct VS_OUTPUT
{
    float4 vpos : SV_Position;
	float2 tex : TEXCOORD;
	float exposure : TEXCOORD1;
	float4 depthPosition : TEXTURE0;
	
};

struct VS_INPUT
{
    float4 pos : SV_Depth;
	float4 tex : TEXCOORD;
};

float readDepth(float2 coord : TEXCOORD)
{

    return 2.0 * near * far / (far + near - (2.0 * gdepth.Sample(gdepthSampler, coord).x - 1.0) * (far - near));
}

	

float4 dip_filter(float3x3 _filter,  Texture2D _texture, float2 _xy, float2 texSize)
{
      float2 _filter_pos_delta[3][3] = 
      {
            { float2(-1.0 , -1.0), float2(0, -1.0), float2(1.0 , -1.0) },
            { float2( 0.0 , -1.0), float2(0, 0.0), float2(1.0 ,  0.0) },
            { float2( 1.0 , -1.0), float2(0, 1.0), float2(1.0 ,  1.0) },
      };

      float4 final_color = float4(0.0,0.0,0.0,0.0); 

      for(int i = 0 ; i < 3 ; i ++ )
      {
            for(int j = 0 ; j < 3 ; j ++)
            {
                  float2 _xy_new = float2(_xy.x + _filter_pos_delta[i][j].x , _xy.y + _filter_pos_delta[i][j].y);
                  float2 _uv_new = float2(_xy_new.x/texSize.x , _xy_new.y/texSize.y);
                  final_color += _texture.Sample( _textureSampler , _uv_new ) * _filter[i][j];

            } 
      }
      return final_color;
}


float4  xposure(float4 _color , float gray , float ex)
{

      float b = (4 * ex -  1);
      float a = 1 - b;
      float f = gray * (a * gray + b);

      return   f * _color;
}

float4 COMMON_Texture(float4 _Color , float4 texCoord :TEXCOORD, Texture2D _texture)

{
      return _texture.Sample(_textureSampler, texCoord.xy) * _Color;
}


float4 CalcHDR(float4 vDiffuse , float4 texCoord :TEXCOORD, Texture2D _texture)

{

      float2    TexSize = float2(8192 , 8192);
      float2    intXY   = float2(texCoord.x * TexSize.x , texCoord.y * TexSize.y);

      float3x3 _smooth_fil = float3x3 (1/16.0 ,2/16.0,1/16.0 ,
                                       2/16.0 ,4/16.0,2/16.0 ,
                                       1/16.0 ,2/16.0,1/16.0 );

      float  _exposure  = 1.2;   

      float4 _dsColor   = dip_filter(_smooth_fil , _texture , intXY, TexSize);
      float  _lum       = (0.3 * _dsColor.x + 0.59 * _dsColor.y + 0.11 * _dsColor.z);
	  
      return float4(xposure(vDiffuse , _lum , _exposure ).xyz , vDiffuse.w);    

}

//--------------------------------------------------------------------------------------
// Vertex Shader - HDR shading
//--------------------------------------------------------------------------------------

VS_OUTPUT VS_HDR(VS_INPUT IN)
{
   	VS_OUTPUT OUT;
	float Exposure;
	OUT.vpos = mul(IN.pos, worldMatrix);
    OUT.vpos = mul(OUT.vpos, viewMatrix);
    OUT.vpos = mul(OUT.vpos, projectionMatrix);
	OUT.vpos=float4(IN.pos.x,IN.pos.y,IN.pos.z,1.0);
	OUT.tex.xy=IN.tex.xy+TempParameters.xy;//1.0/(HDRtexsize*2.0)
	OUT.exposure = pow(2.0, Exposure);
	OUT.depthPosition  = OUT.vpos;

	return OUT;

}
//--------------------------------------------------------------------------------------
// Pixel Shader - HDR Texture shading
//--------------------------------------------------------------------------------------

float4 ps_main(VS_OUTPUT In, float4 vDiffuse : COLOR) : SV_Target
{
	float Gamma;
	float4 color;
	float4 HDRuv;
	float depthValue;
	
	depthValue = In.depthPosition.z / In.depthPosition.w;
	
	float4 HDR = textureLOD1.SampleBias(TextureSampler1, In.tex, 0.0);
	const float2 offset[4]=
	{
		float2(0.25, 1.25),
		float2(0.25, -0.25),
		float2(-0.25, 0.25),
		float2(-0.25, -0.25)
	};

	float2 screenfact=TempParameters.z;
	screenfact.y*=ScreenSize.z;
	float4 srcHDR=HDR;
	for (int i=0; i<4; i++)
	{
		HDRuv.xy=offset[i];
		HDRuv.xy=(HDRuv.xy*screenfact.xy)+In.tex.xy;
		float4 tempHDR=textureLOD1.SampleBias(TextureSampler1, HDRuv.xy, 0.0);
		HDR.xyz+=tempHDR.xyz;
	}
	
	HDR.xyz*=0.25;
	HDR.xyz=min(HDR.xyz, 32768.0);
	HDR.xyz=max(HDR.xyz, 0.0);
	
	HDR=textureLOD1.SampleBias(TextureSampler1, In.tex, 0.0);
	
	const float2 offset0[16]=
	{
		float2(1.0, 1.0),
		float2(1.0, -1.0),
		float2(-1.0, 1.0),
		float2(-1.0, -1.0),
		float2(0.0, 1.0),
		float2(0.0, -1.0),
		float2(1.0, 0.0),
		float2(-1.0, 0.0),
		float2(1.0, 1.0),
		float2(1.0, -1.0),
		float2(-1.0, 1.0),
		float2(-1.0, -1.0),
		float2(0.0, 1.0),
		float2(0.0, -1.0),
		float2(1.0, 0.0),
		float2(-1.0, 0.0)
	};
	
	float step=HDRParameters.x;
	screenfact.xy*=step;

	
	for (int n=0; n<16; n++)
	{
		HDRuv.xy=offset0[n];
		HDRuv.xy=(HDRuv.xy*screenfact.xy)+In.tex.xy;//-(1.0/2048.0);//-(1.0/4096.0);
		float4 tempHDR=textureLOD1.SampleBias(TextureSampler1, HDRuv.xy, 0.0);
		HDR+=tempHDR;
	}

	float3 violet=float3(0.6, 0.4, 1.0);
	float ttt=dot(HDR.xyz, 0.333)-dot(srcHDR.xyz, 0.333);
	ttt=max(ttt, 0.0);
	
	float gray=HDRParameters.z*ttt*10;
	float mixfact=(gray/(1.0+gray));
	
	mixfact*=1.0-saturate((TempParameters.w-1.0)*0.2);
	violet.xy+=saturate((TempParameters.w-1.0)*0.3);
	violet.xy=saturate(violet.xy);
	HDR.xyz*=lerp(1.0, violet.xyz, mixfact);


	HDR=textureLOD1.SampleBias(TextureSampler1, In.tex, 0.0);
	const float2 offset2[16]=
	{
		float2(1.0, 1.0),
		float2(1.0, -1.0),
		float2(-1.0, 1.0),
		float2(-1.0, -1.0),
		float2(0.0, 1.0),
		float2(0.0, -1.0),
		float2(1.0, 0.0),
		float2(-1.0, 0.0),
		float2(1.0, 1.0),
		float2(1.0, -1.0),
		float2(-1.0, 1.0),
		float2(-1.0, -1.0),
		float2(0.0, 1.0),
		float2(0.0, -1.0),
		float2(1.0, 0.0),
		float2(-1.0, 0.0)
	};
	
	float4 rotvec=0.0;
	sincos(0.3927, rotvec.x, rotvec.y);
	for (int j=0; j<16; j++)
	{
		HDRuv.xy=offset2[j];
		HDRuv.xy=reflect(HDRuv.xy, rotvec.xy);
		HDRuv.xy=(HDRuv.xy*screenfact.xy)+In.tex.xy;
		
		float4 tempHDR=textureLOD1.SampleBias(TextureSampler1, HDRuv.xy, 0.0);
		HDR+=tempHDR;
		
	HDR=textureLOD1.Sample(TextureSampler1, In.tex);
	HDR=textureLOD1.SampleBias(TextureSampler1, In.tex, 0.0);
	textureLOD1.CalculateLevelOfDetailUnclamped(TextureSampler1, 0.0);
	HDR+=textureLOD2.Sample(TextureSampler2, In.tex);
	HDR+=textureLOD2.SampleBias(TextureSampler2, In.tex, 0.0);
	textureLOD2.CalculateLevelOfDetailUnclamped(TextureSampler2, 0.0);
	HDR+=textureLOD3.Sample(TextureSampler3, In.tex);
	HDR+=textureLOD3.SampleBias(TextureSampler3, In.tex, 0.0);
	textureLOD3.CalculateLevelOfDetailUnclamped(TextureSampler3, 0.0);
	HDR+=textureLOD4.Sample(TextureSampler4, In.tex);
	HDR+=textureLOD4.SampleBias(TextureSampler4,In.tex, 0.0);
	textureLOD4.CalculateLevelOfDetailUnclamped(TextureSampler4, 0.0);
	HDR+=textureLOD7.Sample(TextureSampler7, In.tex);
	HDR+=textureLOD7.SampleBias(TextureSampler7, In.tex, 0.0);
	textureLOD5.CalculateLevelOfDetailUnclamped(TextureSampler7, 0.0);
	HDR+=textureLOD8.Sample(TextureSampler8, In.tex);
	HDR+=textureLOD8.SampleBias(TextureSampler8, In.tex, 0.0);
	textureLOD8.CalculateLevelOfDetailUnclamped(TextureSampler8, 0.0);
	HDR+=textureLOD5.Sample(TextureSampler5, In.tex);
	HDR+=textureLOD5.SampleBias(TextureSampler5, In.tex, 0.0);
	textureLOD7.CalculateLevelOfDetailUnclamped(TextureSampler5, 0.0);
	HDR+=textureLOD6.Sample(TextureSampler2, In.tex);
	HDR+=textureLOD6.SampleBias(TextureSampler6, In.tex, 0.0);
	textureLOD6.CalculateLevelOfDetailUnclamped(TextureSampler6, 0.0);
	
	}
	
	float2    TexSize = float2(8192 , 8192);
	float2    intXY   = float2(In.tex.x * TexSize.x , In.tex.y * TexSize.y);

	float3x3 _smooth_fil = float3x3 (1/16.0 ,2/16.0,1/16.0 ,
									   2/16.0 ,4/16.0,2/16.0 ,
									   1/16.0 ,2/16.0,1/16.0 );	

	
	HDR*=1.55;
	
	float HDRVal = HDR;
	float2 pos = In.tex;
	float3 c11 = textureLOD1.SampleBias(TextureSampler1, pos.xy, 0.0).xyz;
	float k1 = length(c11);
	float4 bufferData = g_Buffer.Load(1);
	MultisampledTexture.Load(In.tex, 8);
	
	HDR.xyz*=(HDRVal)*c11 + HDRVal*lerp(k1,normalize(float2(k1*k1, 2.75)).x * 1.15, 1.65*k1)+0.4+(float4(depthValue, depthValue, depthValue, 1.0f).xyz);
	
	return HDR;
}



//--------------------------------------------------------------------------------------
#if SHADER_MODEL >= 0x500
technique LightmapPrePass
{
    pass p0
    {
		VertexShader = compile vs_5_0 VS_HDR();
		PixelShader  = compile ps_5_0 ps_main();
		ColorWriteEnable=ALPHA|RED|GREEN|BLUE;
		CullMode=NONE;
		AlphaBlendEnable=TRUE;
		AlphaTestEnable=TRUE;
		SEPARATEALPHABLENDENABLE=TRUE;
		FogEnable=TRUE;
		SRGBWRITEENABLE=TRUE;
    }

}
technique HDRPass
{
    pass p0
    {
		VertexShader = compile vs_5_0 VS_HDR();
		PixelShader  = compile ps_5_0 ps_main();
		ColorWriteEnable=ALPHA|RED|GREEN|BLUE;
		CullMode=NONE;
		AlphaBlendEnable=TRUE;
		AlphaTestEnable=TRUE;
		SEPARATEALPHABLENDENABLE=TRUE;
		FogEnable=TRUE;
		SRGBWRITEENABLE=TRUE;
    }

}
technique LightPostPass
{
    pass p0
    {
		VertexShader = compile vs_5_0 VS_HDR();
		PixelShader  = compile ps_5_0 ps_main();
		ColorWriteEnable=ALPHA|RED|GREEN|BLUE;
		CullMode=NONE;
		AlphaBlendEnable=TRUE;
		AlphaTestEnable=TRUE;
		SEPARATEALPHABLENDENABLE=TRUE;
		FogEnable=TRUE;
		SRGBWRITEENABLE=TRUE;
    }

}
#else
technique LightmapPrePass
{
    pass p0
    {
		VertexShader = compile vs_4_0 VS_HDR();
		PixelShader  = compile ps_4_0 ps_main();
		ColorWriteEnable=ALPHA|RED|GREEN|BLUE;
		CullMode=NONE;
		AlphaBlendEnable=TRUE;
		AlphaTestEnable=TRUE;
		SEPARATEALPHABLENDENABLE=TRUE;
		FogEnable=TRUE;
		SRGBWRITEENABLE=TRUE;
    }

}
technique HDRPass
{
    pass p0
    {
		VertexShader = compile vs_4_0 VS_HDR();
		PixelShader  = compile ps_4_0 ps_main();
		ColorWriteEnable=ALPHA|RED|GREEN|BLUE;
		CullMode=NONE;
		AlphaBlendEnable=TRUE;
		AlphaTestEnable=TRUE;
		SEPARATEALPHABLENDENABLE=TRUE;
		FogEnable=TRUE;
		SRGBWRITEENABLE=TRUE;
    }

}
technique LightPostPass
{
    pass p0
    {
		VertexShader = compile vs_4_0 VS_HDR();
		PixelShader  = compile ps_4_0 ps_main();
		ColorWriteEnable=ALPHA|RED|GREEN|BLUE;
		CullMode=NONE;
		AlphaBlendEnable=TRUE;
		AlphaTestEnable=TRUE;
		SEPARATEALPHABLENDENABLE=TRUE;
		FogEnable=TRUE;
		SRGBWRITEENABLE=TRUE;
    }

}
#endif
#endif